## tree-sitter-yaml 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(tree-sitter-yaml
        VERSION "0.7.2"
        DESCRIPTION "YAML grammar for tree-sitter"
        HOMEPAGE_URL "https://github.com/tree-sitter-grammars/tree-sitter-yaml"
        LANGUAGES C)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(TREE_SITTER_REUSE_ALLOCATOR "Reuse the library allocator" OFF)

set(TREE_SITTER_ABI_VERSION 14 CACHE STRING "Tree-sitter ABI version")
if(NOT ${TREE_SITTER_ABI_VERSION} MATCHES "^[0-9]+$")
    unset(TREE_SITTER_ABI_VERSION CACHE)
    message(FATAL_ERROR "TREE_SITTER_ABI_VERSION must be an integer")
endif()

find_program(TREE_SITTER_CLI tree-sitter DOC "Tree-sitter CLI")

add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/src/parser.c"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/grammar.json"
                   COMMAND "${TREE_SITTER_CLI}" generate src/grammar.json
                            --abi=${TREE_SITTER_ABI_VERSION}
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                   COMMENT "Generating parser.c")

add_library(tree-sitter-yaml src/parser.c)
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/src/scanner.c)
  target_sources(tree-sitter-yaml PRIVATE src/scanner.c)
endif()
target_include_directories(tree-sitter-yaml
                           PRIVATE src
                           INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/bindings/c>
                                     $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)


set(YAML_SCHEMA core CACHE STRING "YAML schema")
set(YAML_SCHEMA_VALUES core json legacy CACHE INTERNAL "Allowed schemas")
set_property(CACHE YAML_SCHEMA PROPERTY STRINGS ${YAML_SCHEMA_VALUES})
if(NOT YAML_SCHEMA IN_LIST YAML_SCHEMA_VALUES)
    message(FATAL_ERROR "YAML_SCHEMA must be one of ${YAML_SCHEMA_VALUES}")
endif()

target_compile_definitions(tree-sitter-yaml PRIVATE
                           $<$<BOOL:${TREE_SITTER_REUSE_ALLOCATOR}>:TREE_SITTER_REUSE_ALLOCATOR>
                           $<$<CONFIG:Debug>:TREE_SITTER_DEBUG>
                           YAML_SCHEMA=${YAML_SCHEMA})

set_target_properties(tree-sitter-yaml
                      PROPERTIES
                      C_STANDARD 11
                      POSITION_INDEPENDENT_CODE ON
                      SOVERSION "${TREE_SITTER_ABI_VERSION}.${PROJECT_VERSION_MAJOR}"
                      DEFINE_SYMBOL "")

configure_file(bindings/c/tree-sitter-yaml.pc.in
               "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-yaml.pc" @ONLY)

include(GNUInstallDirs)

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bindings/c/tree_sitter"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
        FILES_MATCHING PATTERN "*.h")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-yaml.pc"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig")
install(TARGETS tree-sitter-yaml
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

file(GLOB QUERIES queries/*.scm)
install(FILES ${QUERIES}
        DESTINATION "${CMAKE_INSTALL_DATADIR}/tree-sitter/queries/yaml")

add_custom_target(ts-test "${TREE_SITTER_CLI}" test
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  COMMENT "tree-sitter test")

=== Makefile ===
ifeq ($(OS),Windows_NT)
$(error Windows is not supported)
endif

LANGUAGE_NAME := tree-sitter-yaml
HOMEPAGE_URL := https://github.com/tree-sitter-grammars/tree-sitter-yaml
VERSION := 0.7.2

# repository
SRC_DIR := src

TS ?= tree-sitter

# install directory layout
PREFIX ?= /usr/local
DATADIR ?= $(PREFIX)/share
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
PCLIBDIR ?= $(LIBDIR)/pkgconfig

# source/object files
PARSER := $(SRC_DIR)/parser.c
EXTRAS := $(SRC_DIR)/scanner.c
OBJS := $(patsubst %.c,%.o,$(PARSER) $(EXTRAS))

# schema
YAML_SCHEMA := core
ifeq ($(filter $(YAML_SCHEMA),core json legacy),)
$(error YAML_SCHEMA must be one of core/json/legacy)
endif

# flags
ARFLAGS ?= rcs
override CFLAGS += -I$(SRC_DIR) -std=c11 -fPIC -DYAML_SCHEMA=$(YAML_SCHEMA)

# ABI versioning
SONAME_MAJOR = $(shell sed -n 's/\#define LANGUAGE_VERSION //p' $(PARSER))
SONAME_MINOR = $(word 1,$(subst ., ,$(VERSION)))

# OS-specific bits
ifeq ($(shell uname),Darwin)
	SOEXT = dylib
	SOEXTVER_MAJOR = $(SONAME_MAJOR).$(SOEXT)
	SOEXTVER = $(SONAME_MAJOR).$(SONAME_MINOR).$(SOEXT)
	LINKSHARED = -dynamiclib -Wl,-install_name,$(LIBDIR)/lib$(LANGUAGE_NAME).$(SOEXTVER),-rpath,@executable_path/../Frameworks
else
	SOEXT = so
	SOEXTVER_MAJOR = $(SOEXT).$(SONAME_MAJOR)
	SOEXTVER = $(SOEXT).$(SONAME_MAJOR).$(SONAME_MINOR)
	LINKSHARED = -shared -Wl,-soname,lib$(LANGUAGE_NAME).$(SOEXTVER)
endif
ifneq ($(filter $(shell uname),FreeBSD NetBSD DragonFly),)
	PCLIBDIR := $(PREFIX)/libdata/pkgconfig
endif

all: lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT) $(LANGUAGE_NAME).pc

lib$(LANGUAGE_NAME).a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

lib$(LANGUAGE_NAME).$(SOEXT): $(OBJS)
	$(CC) $(LDFLAGS) $(LINKSHARED) $^ $(LDLIBS) -o $@
ifneq ($(STRIP),)
	$(STRIP) $@
endif

$(LANGUAGE_NAME).pc: bindings/c/$(LANGUAGE_NAME).pc.in
	sed -e 's|@PROJECT_VERSION@|$(VERSION)|' \
		-e 's|@CMAKE_INSTALL_LIBDIR@|$(LIBDIR:$(PREFIX)/%=%)|' \
		-e 's|@CMAKE_INSTALL_INCLUDEDIR@|$(INCLUDEDIR:$(PREFIX)/%=%)|' \
		-e 's|@PROJECT_DESCRIPTION@|$(DESCRIPTION)|' \
		-e 's|@PROJECT_HOMEPAGE_URL@|$(HOMEPAGE_URL)|' \
		-e 's|@CMAKE_INSTALL_PREFIX@|$(PREFIX)|' $< > $@

$(PARSER): $(SRC_DIR)/grammar.json
	$(TS) generate $^

install: all
	install -d '$(DESTDIR)$(DATADIR)'/tree-sitter/queries/yaml '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter '$(DESTDIR)$(PCLIBDIR)' '$(DESTDIR)$(LIBDIR)'
	install -m644 bindings/c/tree_sitter/$(LANGUAGE_NAME).h '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h
	install -m644 $(LANGUAGE_NAME).pc '$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc
	install -m644 lib$(LANGUAGE_NAME).a '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a
	install -m755 lib$(LANGUAGE_NAME).$(SOEXT) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT)
	install -m644 queries/*.scm '$(DESTDIR)$(DATADIR)'/tree-sitter/queries/yaml

uninstall:
	$(RM) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT) \
		'$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h \
		'$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc
	$(RM) -r '$(DESTDIR)$(DATADIR)'/tree-sitter/queries/yaml

clean:
	$(RM) $(OBJS) $(LANGUAGE_NAME).pc lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT)

test:
	$(TS) test

.PHONY: all install uninstall clean test

=== debian/changelog ===
tree-sitter-yaml (0.7.2-1) unstable; urgency=medium

  * Package tree-sitter-yaml 0.7.2 from git
  * Closes: #1118223.

 -- Antonin Delpeuch <antonin@delpeuch.eu>  Sun, 15 Feb 2026 17:12:58 +0100

=== debian/control ===
Source: tree-sitter-yaml
Priority: optional
Maintainer: Tree-sitter Team <team+tree-sitter@tracker.debian.org>
Uploaders: Antonin Delpeuch <antonin@delpeuch.eu>
Build-Depends:
 cargo:native,
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev,
 librust-tree-sitter-0.25+default-dev (>= 0.25.0-~~),
 nodejs,
 rustc:native,
 tree-sitter-cli (>= 0.25),
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/tree-sitter-grammars/tree-sitter-yaml
Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter-yaml.git
Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter-yaml

Package: tree-sitter-yaml-src
Architecture: all
Depends:
 ${misc:Depends},
 gcc,
 libc6-dev | libc-dev,
 libtree-sitter-dev (>= 0.25),
 make,
 pkgconf,
Description: YAML parser for Tree-sitter (source files)
 This package contains the generated source files for building the YAML parser
 shared object.

Package: librust-tree-sitter-yaml-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev
Provides:
 librust-tree-sitter-yaml+default-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0.7-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0.7+default-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0.7.2-dev (= ${binary:Version}),
 librust-tree-sitter-yaml-0.7.2+default-dev (= ${binary:Version})
Description: YAML grammar for the tree-sitter parser - Rust source code
 tree-sitter-yaml is a tree-sitter grammar for YAML.
 .
 Tree-sitter is a parser generator and incremental parsing library.
 .
 This package contains the source for the Rust tree-sitter-yaml crate,
 packaged for use with cargo.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export TREE_SITTER_SRC_DIR = /usr/src/tree-sitter/yaml/${DEB_VERSION_UPSTREAM}/

%:
	dh $@

debian/%: debian/%.in
	sed "s/@PARSER_VER@/$(DEB_VERSION_UPSTREAM)/g" $< > $@

override_dh_auto_build:
	tree-sitter generate --abi $(shell sed -n 's/#define LANGUAGE_VERSION //p' src/parser.c)
	dh_auto_build --buildsystem=rust

# Do not run Makefile install
override_dh_auto_install:
	dh_auto_install --buildsystem=rust

override_dh_install: debian/Makefile
	dh_install

override_dh_auto_test:
	XDG_CACHE_HOME=$(CURDIR)/debian/.cache tree-sitter test
	dh_auto_test --buildsystem=rust

=== debian/tests/control ===
Tests: smoke
Depends: tree-sitter-cli, tree-sitter-yaml-src

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-yaml 0.7.2 --all-targets --all-features
Features: test-name=rust-tree-sitter-yaml:@
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-yaml 0.7.2 --all-targets
Features: test-name=librust-tree-sitter-yaml-dev:default
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-yaml 0.7.2 --all-targets --no-default-features
Features: test-name=librust-tree-sitter-yaml-dev:
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

=== debian/watch ===
Version: 5

Source: https://github.com/tree-sitter-grammars/tree-sitter-yaml/tags
Matching-Pattern: .*/v?(\d\S*)@ARCHIVE_EXT@
